<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Fundraising;
use App\Document;
use DB;
use Auth;
use App\Donation;
use Session;
use Carbon\Carbon;
use Image;
use App\Withdraw;

class FundController extends Controller
{
    public function addfundraiser(Request $request){

        if($request->isMethod('post')){
            $data = $request->all();
            //echo "<pre>";print_r($data);die();
            $fundraising = new Fundraising;
            $fundraising->user_id = Auth::user()->id;
            $fundraising->title = $data['title'];
            $fundraising->description = $data['description'];
            $fundraising->category_id = $data['category'];
            $fundraising->total_fund_required = $data['fund_required'];
            $fundraising->end_date = Carbon::now()->addDays($data['no_of_days']);
            $fundraising->name = $data['name'];
            $fundraising->father_name = $data['father_name'];
            $fundraising->mobile_no = $data['mobile'];
            $fundraising->alternet_no = $data['alternate_mo'];
            $fundraising->address_1 = $data['address_1'];
            $fundraising->address_2 = $data['address2'];
            $fundraising->city = $data['city'];
            $fundraising->state = $data['state'];
            $fundraising->zip = $data['zip'];
            $fundraising->country = $data['country'];
            if($request->hasFIle('image')){
                //echo "hello";die();
                $image_tmp = $request->image;

                if ($image_tmp->isValid()) {
                    //upload images after resize
                    $extension = $image_tmp->getClientOriginalExtension();
                    $fileName = rand(111,99999).'.'.$extension;
                    $large_image_path = 'images/backend_images/fundraising/large'.'/'.$fileName;
                    $medium_image_path = 'images/backend_images/fundraising/medium'.'/'.$fileName;
                    $small_image_path = 'images/backend_images/fundraising/small'.'/'.$fileName;

                    Image::make($image_tmp)->save($large_image_path);
                    Image::make($image_tmp)->resize(600,600)->save($medium_image_path);
                    Image::make($image_tmp)->resize(300,300)->save($small_image_path);

                    $fundraising->image = $fileName;
                }
            }
            $fundraising->save();

            $fundraising_id = DB::getPdo()->lastInsertId();

            if($request->hasFile('document')){
                foreach ($request->document as $doc) {
                    
                    $path = storage_path('tmp/uploads');
                    if (!file_exists($path)) {
                        mkdir($path, 0777, true);
                    }
                    
                    $name = time() . '_' . trim($doc->getClientOriginalName());

                    $doc->move($path, $name);

                    $document = new Document;
                    $document->name = $name;
                    $document->user_id = Auth::user()->id;
                    $document->fundraising_id = $fundraising_id;
                    $document->save();

                }
            }

        return redirect('/users/fundraising');
            
        }
        return view('users.fundraising.addfundraiser');
    }

    public function fundraisings($id){

        $fundraising = Fundraising::where('id',$id)->get()->first();
        return view('users.fundraising.fundraising_detail')->with(compact('fundraising'));
    }

    public function donate_money(Request $request, $id){

        

        $fundraising = Fundraising::where('id',$id)->get()->first();
        return view('users.donation.donate_money')->with(compact('fundraising'));
    }

    

    public function donate_method(Request $request){

        $merchant_id = '175158702325924';
        $secretkey = '19324-602';
        
        
                 

        if(isset($_GET['status_id']) && isset($_GET['order_id']) && isset($_GET['msg']) && isset($_GET['transaction_id']) && isset($_GET['hash']))
        {
            # verify that the data was not tempered, verify the hash
            $hashed_string = hash_hmac('sha256', $secretkey.urldecode($_GET['status_id']).urldecode($_GET['order_id']).urldecode($_GET['transaction_id']).urldecode($_GET['msg']), $secretkey);
        
             # if hash is the same then we know the data is valid
            if($hashed_string == urldecode($_GET['hash']))
            {
                # this is a simple result page showing either the payment was successful or failed. In real life you will need to process the order made by the customer
                if(urldecode($_GET['status_id']) == '1'){
                    echo 'Payment was successful with message: '.urldecode($_GET['msg']);
                    $donation = new Donation;
                    $donation->name = Session::get('name');
                    $donation->mobile = Session::get('mobile');
                    $donation->amount = Session::get('amount');
                    $donation->detail = Session::get('detail');
                    $donation->order_id = Session::get('order_id');
                    $donation->paid_to = Session::get('paid_to');
                    $donation->Anonymous = Session::get('Anonymous');

                    
                    if(!empty(Auth::check())){
                        $donation->paid_by = Auth::user()->id;
                    }
                    $donation->save();
                    return redirect('/thanks')->with('flash_message_success','Donation Successful! Thanks for your donation');

                }
                else{
                    
                    //echo 'Payment failed with message: '.urldecode($_GET['msg']);
                    return redirect('/thanks')->with('flash_message_error', 'Donation not successful'.urldecode($_GET['msg']));
                }
            }
            else{
                echo 'Hashed value is not correct';
            
            }

        }

        
    }

    public function senangpay_response(){

         $merchant_id = '175158702325924';
                $secretkey = '19324-602';

        if(isset($_GET['status_id']) && isset($_GET['order_id']) && isset($_GET['msg']) && isset($_GET['transaction_id']) && isset($_GET['hash']))
        {
            # verify that the data was not tempered, verify the hash
            $hashed_string = hash_hmac('sha256', $secretkey.urldecode($_GET['status_id']).urldecode($_GET['order_id']).urldecode($_GET['transaction_id']).urldecode($_GET['msg']), $secretkey);
        
             # if hash is the same then we know the data is valid
            if($hashed_string == urldecode($_GET['hash']))
            {
                # this is a simple result page showing either the payment was successful or failed. In real life you will need to process the order made by the customer
                if(urldecode($_GET['status_id']) == '1')
                    echo 'Payment was successful with message: '.urldecode($_GET['msg']);
                else
                    echo 'Payment failed with message: '.urldecode($_GET['msg']);
                }
            else
                echo 'Hashed value is not correct';
            }

        }

    public function withdraw(Request $request, $id){

        $data = $request->all();
        //echo "<pre>";print_r($data);die();
        $withdraw = new Withdraw;
        $withdraw->fundraising_id = $id;
        $withdraw->message = $data['message'];
        $withdraw->amount = $data['amount'];
        $withdraw->save();

        return redirect()->back()->with('flash_message_success', 'Request Submitted wait for the admin response');
    }
}
