<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\SubscriptionPlan;
use App\Subscription;
use App\Payment;
use DB;
use Auth;
use Carbon\Carbon;

class PaymentController extends Controller {
   
   public function plan(Request $request, $id){
        

      $plan  = SubscriptionPlan::find($id);
     	return view('users.plan',compact('plan'));
   	}	
    public function plandetails($id){
        $plan = SubscriptionPlan::where('id', $id)->first();
        return view('users.plan_details')->with(compact('plan'));  
    }
    public function subscribe_plan(Request $request){

      if($request->isMethod('post')){
        $data = $request->all();
        //echo "<pre>";print_r($data);die();
        $payment = new Payment;
        $payment->transaction_id = $data['payment_id'];
        $payment->user_id = Auth::user()->id;
        $payment->plan_id = $data['plan_id'];
        $payment->amount = $data['amount'];
        $payment->save();

        $payment_id = DB::getPdo()->lastInsertId();
        
        $subscription = new Subscription;
        $subscription->user_id = Auth::user()->id;
        $subscription->plan_id = $data['plan_id'];        
        $subscription->amount = $data['amount'];
        $subscription->save();

        $arr = array('msg'=>'You are subscribed now','status'=>true);
        return response()->json($arr);
  


      }
    }


   public function cancel(){
    return view('users.index')->with('flash_message_error', 'Payment Cancelled');
   }

   public function free_trial($id){

      $count_subscription = Subscription::where('user_id', Auth::user()->id)->count();
      if($count_subscription > 0){
          return redirect()->back()->with('flash_message_error','You have already availed your free trial');
      }

      $subscription = new Subscription;
      $subscription->user_id = Auth::user()->id;
      $subscription->plan_id = $id;
      $plan = SubscriptionPlan::where('id', $id)->first();
      $subscription->amount = $plan->amount;
      $subscription->save();

      return redirect()->back()->with('flash_message_success','Your free trial subscription is under approval, we will send your user id and password to your email once we approve your request');

    }
}
